/**
 * Created by filip on 24.06.2017.
 */

var contacts = [
    {
        "id": 0,
        "name": "Pavla",
        "surname": "Horáková",
        "tags": ["kamoska", "spoluzacka", "volejbal"],
        "email": "hora.pavla@seznam.cz",
        "secondEmail": "pavla@horakova.cz",
        "phone": "+420 737 028 937",
        "oldPhone": "+420 301 529 361",
        "fax": "387 390 419",
        "address": {"street": "Slivenická 9", "city": "940 Žlutice"}
    },
    {"id": 1, "name": "Jan", "surname": "Novák"},
    {"id": 2, "name": "Filip", "surname": "Skočdopole"},
    {"id": 3, "name": "Dan", "surname": "Nguyen"}
];

var vcard = '<svg width="20px" height="17px" viewBox="0 0 2048 1792" xmlns="http://www.w3.org/2000/svg"><path d="M1024 1131q0-64-9-117.5t-29.5-103-60.5-78-97-28.5q-6 4-30 18t-37.5 21.5-35.5 17.5-43 14.5-42 4.5-42-4.5-43-14.5-35.5-17.5-37.5-21.5-30-18q-57 0-97 28.5t-60.5 78-29.5 103-9 117.5 37 106.5 91 42.5h512q54 0 91-42.5t37-106.5zm-157-520q0-94-66.5-160.5t-160.5-66.5-160.5 66.5-66.5 160.5 66.5 160.5 160.5 66.5 160.5-66.5 66.5-160.5zm925 509v-64q0-14-9-23t-23-9h-576q-14 0-23 9t-9 23v64q0 14 9 23t23 9h576q14 0 23-9t9-23zm0-260v-56q0-15-10.5-25.5t-25.5-10.5h-568q-15 0-25.5 10.5t-10.5 25.5v56q0 15 10.5 25.5t25.5 10.5h568q15 0 25.5-10.5t10.5-25.5zm0-252v-64q0-14-9-23t-23-9h-576q-14 0-23 9t-9 23v64q0 14 9 23t23 9h576q14 0 23-9t9-23zm256-320v1216q0 66-47 113t-113 47h-352v-96q0-14-9-23t-23-9h-64q-14 0-23 9t-9 23v96h-768v-96q0-14-9-23t-23-9h-64q-14 0-23 9t-9 23v96h-352q-66 0-113-47t-47-113v-1216q0-66 47-113t113-47h1728q66 0 113 47t47 113z"/></svg>';

var currentContact;

$(document).ready(function () {

    for (var i = 65; i <= 90; i++) {
        var letter = String.fromCharCode(i);

        $('.alphabet').append('<div class="letter" id="' + letter + '">' + letter + '</div>');
    }

    renderNames();


    $('.hideNames').click(function () {
        $('.name').toggle();
    });

    $('.delete').click(function () {
        if (confirm("Opravdu chcete smazat všechny kontakty?")) {
            contacts = null;
            renderNames();
            renderDefault();
        }
    });


    $('.letter').click(function (e) {

        e.target
        $('.contacts').scrollTo(20, 20);
    });


    $('.contact').on('click',function (e) {
        renderContact(e.target.id);
    });

    $('.edit').click(function(){
        renderEdit();
    });

    $('.save-contact').click(function(){
        saveContact();
    });

    $('.delete-contact').click(function(){
        var index = contacts.indexOf(currentContact);
        if (index > -1) {
            contacts.splice(index, 1);
        }
        renderDefault();
    });
});

function renderDefault(){
    $('#homepage').removeClass('hidden');
    $('#editpage').addClass('hidden');
    $('#contactpage').addClass('hidden');

    renderNames();

    $('.contact').on('click',function (e) {
        renderContact(e.target.id);
    });
}

function renderNames() {

    if (contacts === null) {
        $('.list').html("");
        return 0;
    }
    contacts.sort(function (a, b) {
        return b.surname < a.surname;
    });

    $('.list').html("");
    contacts.map(function (contact) {
        $('.list').append('<div class="contact" id="' + contact.id + '">' + vcard + ' <div class="name">' + contact.name + '</div> ' + contact.surname + '</div>');
    });
}

function renderContact(id) {
    setCurrentContact(id);

    $('#homepage').addClass('hidden');
    $('#editpage').addClass('hidden');
    $('#contactpage').removeClass('hidden');

    $('.contactHeader').text(currentContact.name + ' ' + currentContact.surname);
    $('.contactName').text(currentContact.name);
    $('.contactSurname').text(currentContact.surname);


    $('.contactStitky').text((currentContact.tags !== undefined) ? currentContact.tags.map(function (tag) {
        return " #" + tag;
    }) : "");

    $('.contactEmail').text((currentContact.email !== undefined) ? currentContact.email : "");
    $('.contactSecondEmail').text((currentContact.secondEmail !== undefined) ? currentContact.secondEmail : "");
    $('.contactPhone').text((currentContact.phone !== undefined) ? currentContact.phone : "");
    $('.contactOldPhone').text((currentContact.oldPhone !== undefined) ? currentContact.oldPhone : "");
    $('.contactFax').text((currentContact.fax !== undefined) ? currentContact.fax : "");
    $('.contactAddress').html((currentContact.address !== undefined) ? currentContact.address.street+"<br>"+currentContact.address.city : "");

}

function setCurrentContact(id){
    contacts.forEach(function (contact) {
        if (contact.id === parseInt(id)) {
            currentContact = contact;
        }
    });
}

function renderEdit(){

    $('#contactpage').addClass('hidden');
    $('#editpage').removeClass('hidden');

    $('.editHeader').text(currentContact.name + ' ' + currentContact.surname);
    $('.editName input').val(currentContact.name);
    $('.editSurname input').val(currentContact.surname);


    $('.editStitky input').val((currentContact.tags !== undefined) ? currentContact.tags.map(function (tag) {
        return " #" + tag;
    }) : "");

    $('.editEmail input').val((currentContact.email !== undefined) ? currentContact.email : "");
    $('.editSecondEmail input').val((currentContact.secondEmail !== undefined) ? currentContact.secondEmail : "");
    $('.editPhone input').val((currentContact.phone !== undefined) ? currentContact.phone : "");
    $('.editOldPhone input').val((currentContact.oldPhone !== undefined) ? currentContact.oldPhone : "");
    $('.editFax input').val((currentContact.fax !== undefined) ? currentContact.fax : "");
    $('.editAddress input:first-child').val((currentContact.address !== undefined) ? currentContact.address.street: "");

    $('.editAddress input:last-child').val((currentContact.address !== undefined) ? currentContact.address.city: "");

}

function saveContact(){
    $('#contactpage').removeClass('hidden');
    $('#editpage').addClass('hidden');


    currentContact.name=$('.editName input').val();
    currentContact.surname=$('.editSurname input').val();

    currentContact.email =$('.editEmail input').val();
    currentContact.secondEmail=$('.editSecondEmail input').val();
    currentContact.phone=$('.editPhone input').val();
    currentContact.oldPhone=$('.editOldPhone input').val();
    currentContact.fax =$('.editFax input').val();

    if(currentContact.address!==undefined){
    currentContact.address.street=$('.editAddress input:first-child').val();

    currentContact.address.city=$('.editAddress input:last-child').val();
    }else{
        currentContact.address={"street":$('.editAddress input:first-child').val(),"city":$('.editAddress input:last-child').val()}
    }

    renderContact(currentContact.id);
}
